module Mongoid
  module Oslc
    class QuerySyntaxError < Exception
      attr :query
      def initialize(message, query = nil)
        @query = query
        super(message)
      end
    end

    class QueryParsingError < Exception
      attr :query, :index
      def initialize(query = "", index = 0, message = "")
        @query = query
        @index = index
        super("Parse error at offset: #{@index} #{highlight_error(@query, @index)}")
      end

      protected

      def highlight_error(str, index)
        error_str = "\n#{str}\n"
        (index - 1).times { error_str << "-" }
        error_str << "^"
      end
    end
  end
end
