module Mongoid
  module Oslc
    class Resources < Hash
      def initialize
        super{|h, k| h[k] = {fields: {}}}
      end

      def class_for(rdf_type)
        self.select{|klass,properties| properties[:describe] == rdf_type}.keys.first
      end

      def domain(rdf_type)
        self[class_for(rdf_type)][:domain]
      end

      def mapping
        self.inject({}){|hash, klass| hash.merge(klass[1][:fields]) }
      end

      def field_name(oslc_name)
        if custom_field?(oslc_name)
          oslc_name.split(":")[1].to_sym
        else
          mapping[oslc_name][:name]
        end
      end

      def is_field_array?(oslc_name)
        if custom_field?(oslc_name)
          false
        else
          occurs = self.mapping[oslc_name][:occurs]
          occurs == ::Oslc::ZERO_OR_MANY || occurs == ::Oslc::ONE_OR_MANY
        end
      end

      private

      def custom_field?(oslc_name)
        Mongoid::Oslc.config.default_namespaces.include? oslc_name.split(":")[0].to_sym
      end
    end
  end
end
