require 'treetop'
require 'mongoid/oslc/grammar'

module Mongoid
  module Oslc
    class Strategy
      attr_reader :parser

      def self.to_query(query, *args)
        options = { :verbose => true }
        options.merge!(args.extract_options!)

        Treetop.load File.join(File.dirname(__FILE__), "grammar")
        @parser = GrammarParser.new

        tree = @parser.parse(query)
        raise Mongoid::Oslc::QueryParsingError.new(query, @parser.index) if tree.nil?

        tree.to_mongo_query
      end
    end
  end
end
